<script>
export const ARROW_LEFT="left";
export const ARROW_RIGHT="right";
</script>

<script setup>
import gsap from 'gsap';

  const props = defineProps({
      dateData: {
      type: Object,
      required: true
    },
    url: {
      type: String,
      required: false
    },
		vright: {
			type: Boolean
    },
		vleft: {
			type: Boolean
		}
  });

watch (props.dateData, () => {
    // reaffichage du panneau apres un mouvement des flèches
    if (carousselEnMouvement.value){

      carousselEnMouvement.value=false;

      const timeLine = gsap.timeline();
      
      // PUIS décalage au centre
      timeLine.duration (0.5);
      timeLine.to ("#titleSlider",{left: "0px", scale: 1, opacity: 1},0.5);
      timeLine.to ("#slider",{left: "0px", scale: 1, opacity: 1},0.5);

      // PUIS on réaffiche le titre
      timeLine.duration (0.5);
      timeLine.to ("#titlePage",{scale: 1, opacity: 1},0.5);
    }
  }
  );

const emit = defineEmits(["arrow"]);

const carousselEnMouvement = ref (false);

const description = computed (()=>{
  var descriptionValue=props.dateData.associated_dates[findDateIndexInAssociatedDates (props.dateData)].description;
  return  descriptionValue?descriptionValue:props.dateData.event.description;
});

function clickArrow (direction) {

  // on difinit l'animation
  if (direction==ARROW_LEFT){
      moveLeft ();
  }else if (direction==ARROW_RIGHT){
    moveRight ();
  }
}

function moveLeft () {
  const timeLine = gsap.timeline();

  carousselEnMouvement.value=true;

  // décalage à gauche
  timeLine.duration (0.5);
  timeLine.to ("#titleSlider",{left: "-2000px", scale: 0, opacity: 0},0);
  timeLine.to ("#slider",{left: "-2000px", scale: 0, opacity: 0},0);

  // on effasse le titre
  timeLine.duration (0.5);
  timeLine.to ("#titlePage",{scale: 0, opacity: 0},0);

  // positionne à extreme droite
  timeLine.set ("#titleSlider",{left: "2000px"},0.5);
  timeLine.set ("#slider",{left: "2000px",onComplete: finGauche},0.5);
}

function finGauche () {
  emit('arrow', ARROW_LEFT);
}

function moveRight () {
  const timeLine = gsap.timeline();

  carousselEnMouvement.value=true;

  // décalage à droite
  timeLine.duration (0.5);
  timeLine.to ("#titleSlider",{left: "2000px", scale: 0, opacity: 0},0);
  timeLine.to ("#slider",{left: "2000px", scale: 0, opacity: 0},0);

  // on effasse le titre
  timeLine.duration (0.5);
  timeLine.to ("#titlePage",{scale: 0, opacity: 0},0);

  // positionne à extreme gauche
  timeLine.set ("#titleSlider",{left: "-2000px"},0.5);
  timeLine.set ("#slider",{left: "-2000px",onComplete: finDroite},0.5);
}

function finDroite () {
  emit('arrow', ARROW_RIGHT);
}
</script>

<template >
  <div class="flex flex-col mx-auto">
        <SectionTitle id="titlePage" :title="props.dateData.name?props.dateData.name:props.dateData.event.name" hx="h2" :quoteRight="true" :decaldeLeft="true" />
        <div class="flex flex-row">
          <div class="grow"></div>
          <IconsArrowLeft @click="clickArrow (ARROW_LEFT)" :visible="vleft" classCSS=" hover:shadow-none hover:scale-125 " />
          <div id="titleSlider" class="relative left-0 w-full flex flex-col mx-auto" >
            <h3 class="min-w-96">{{ (props.dateData.name!=null)?props.dateData.event.name:"" }}</h3>
        </div>
          <IconsArrowRight @click="clickArrow (ARROW_RIGHT)" :visible="vright" classCSS=" hover:shadow-none hover:scale-125 " />
          <div class="grow"></div>
        </div>
  </div>

    <!-- block RS-->
  <div id="slider" class="relative left-0 w-full flex flex-col mx-auto" >
    <div class="flex flex-row mx-auto">
      <buttonInstagram :url="url" class="button-link-page scale-150" />
      <buttonFacebook :url="url" class="button-link-page scale-150" />
      <buttonCopyLink :url="url" class="button-link-page scale-150" />
    </div>
    
    <ul class="flex flex-row space-x-2 align-middle mt-2 text-lg justify-middle mx-auto">
      <li class="p-2 leading-none">Lieu</li>
      <li class="inline-block rounded-2xl bg-white text-black shadow-las p-2 leading-none">{{ props.dateData.location.name }}</li>
      <li class="p-2 leading-none">Organisé par</li>
      <li class="inline-block rounded-2xl bg-white text-black shadow-las p-2 leading-none">{{ props.dateData.event.main_organizer[0].name }}</li>
      <li v-for="organizer in props.dateData.event_other_organizers" class="inline-block rounded-2xl bg-white shadow-las p-2 leading-none">{{ organizer.name }}</li>
    </ul>

    <ul class="flex flex-row space-x-2 align-middle mt-2 mb-4 text-lg justify-middle mx-auto">
      <!-- loop prices -->
      <li v-for="(price, index) in props.dateData.event.prices" :keys="index" class="flex flex-row space-x-2">
        <span class="p-2 inline-block leading-none">{{ price.name }}</span>
        <span class="inline-block rounded-2xl bg-white text-black shadow-las p-2 leading-none text-nowrap">{{ price.value }} &euro;</span>
        <span class="inline-block">
        <a :href="price.ticket_office" target="_blank" class="grid grid-flow-col auto-cols-max space-x-2 rounded-2xl bg-white shadow-las p-2 leading-none">
          <img src="/images/Billetterie.svg" alt="ticket image" />
          <span class="leading-none text-black">{{ price.ticket_office }}</span>
        </a>
      </span>
      </li>
      <!-- /loop prices -->
    </ul>
    <hr class="w-full border-las-grey border-b-1 h-[1px] mb-6" />
    <p class="text-left text-base">{{ description }}</p>
  </div>
</template>
<style scoped>  
  .button-link-page {
    display: flex;
    margin: 5px;

    padding: 4px;
  }

  .button-link-page:hover {
    cursor: pointer;
  }

</style>
